package com.tolstoy.imagemeister;

import java.awt.*;
import java.awt.image.*;
import java.io.File;
import java.io.PrintStream;
import java.util.Date;
import com.jconfig.*;

/**
Interface for objects which display information about files. For a given plugin, objects
which implement this interface will be returned from the plugin's createInfoViewer() method.

Copyright (c) 1998-2002 Samizdat Productions. All Rights Reserved. ImageMeister is a Trademark of Samizdat Productions.
*/

public interface InfoViewerI {
	static final String copyright="ImageMeister Copyright (c) 1998-2002 Samizdat Productions. All Rights Reserved. ImageMeister is a Trademark of Samizdat Productions.";

/**
Returns the FileSpecifier which specifies the file shown by this viewer.
*/

	FileSpecifier getFileSpecifier();

/**
Returns the OwnedFrame containing this viewer.
*/

	OwnedFrame getFrame();

/**
Show or hide this viewer.
@param bState if false, hide; if true, show
*/

	void setVisible( boolean bState );
}
